(function( $ ) {
 

	$.fn.pivot = function(options) {
	
		$(".pivotAddNewResult").click(function(){
			pivotAddResultPage();
		});
		
    
		$.fn.pivot.options = $.extend({}, $.fn.pivot.options, options);
		var opt=$.fn.pivot.options;
		
		var pivotFields=[];
		
		$.fn.pivot.data=pivotDataSetup(this);
		var data=$.fn.pivot.data;
		
		$(opt.modal + " div.pivotFields").html("");	//field alanini bosaltalim
 
		for(var i=0;i<data.cols.length;i++)
		{ 
			$(opt.modal + " div.pivotFields").append('<a class="btn btn-mini pivotFieldButtons" alt="'+data.cols[i]+'" >'+data.cols[i]+'</a>')
		}
		
		
		$( ".pivotDrop" ).sortable({
			start:function(){
				$(this).droppable( "disable" );	
			},
			stop:function(){
				$(this).droppable( "enable" );	
				pivotCalculate($.fn.pivot.data);	
			}
		})


		$('a.pivotFieldButtons').draggable({ 
			containment: opt.modal,
			revert: true , 
			revertDuration: 100,
			//helper: 'clone',
			delay:100,
			//connectToSortable: ".pivotDrop",
			stop:function(event,ui){
				//console.log('1.drag', event, ui)
			}
		});	
		
	
		$( ".pivotDrop" ).droppable({ 
			accept: ".pivotFieldButtons",
			hoverClass: "drop-hover",
			drop: function( event, ui ) { 
			 
			 
				if($(this).hasClass('pivotTrash'))	//cop
				{	
					$('div.pivotDrop').find('a.pivotFieldButtons.clone[alt='+ui.helper.html()+']').remove();
					pivotCalculate($.fn.pivot.data);	
					return;
				}			 
			 
				//clone ozelligi sayesinde eklenmis olanlari saymam gerektiginde sayabilirim
				var button='<a class="btn btn-mini pivotFieldButtons clone" alt="'+ui.helper.html()+'">'+ui.helper.html()+'</a>'; 	
				
				//clonelari oldur!
				if(!$(this).hasClass('pivotDataFields'))	//bu alana her field gelebilir //diger alanlardan birine girebilir
				{	 
					$('div.pivotDrop:not(.pivotDataFields)').find('a.pivotFieldButtons.clone[alt='+ui.helper.html()+']').remove();
				}			
				
				var count=$(this).find('a.pivotFieldButtons[alt='+ui.helper.html()+']');
				
				if(count.length==0){
					$(this).append(button);
					console.log("ekledim");
				}
		 
				pivotCalculate($.fn.pivot.data);
								
			}
		});
	
	

	$(opt.modal).on('show', function () {
		
	});	  
	
  }; 
  
  
  $.fn.pivot.data={};	//buraya butun data gelecek
  
  $.fn.pivot.options = {
      modal : '#pivotModal'  
  }    
  
  $.fn.pivot.show=function()
  {  
	$($.fn.pivot.options.modal).modal('show');  
  }
    
  $.fn.pivot.hide=function()
  {  
	$($.fn.pivot.options.modal).modal('hide');  
  }
  
  
	
	
	function pivotAddResultPage(){
		var maxTab=parseInt($('.pivotResults div.tab-pane:last').attr("number"));
		
		$('.pivotResultTab ul .active').removeClass('active');
		$('.pivotResults .active').removeClass('active');
		
		var old=$(".pivotResultTab ul:first").append('<li id="pivotResultTab'+(maxTab+1)+'" class="active"><a data-toggle="tab" href="#pivotResult'+(maxTab+1)+'">Result #'+(maxTab+1)+'<i class="icon-remove cursor pivotCloseResultTab" number="'+(maxTab+1)+'"/></a></li>');

		$(".pivotResults").append('<div class="tab-pane active" id="pivotResult'+(maxTab+1)+'" number="'+(maxTab+1)+'">'+pivotResultTabHtml()+'</div>');
 
		$(".pivotCloseResultTab").click(function(){
			pivotCloseResult(this)
		})		
	}
	
	
	function pivotResultTabHtml()
	{
		return '<div class="row-fluid"><div class="span12 pivotResultFilterArea"></div></div><div class="row-fluid"><div class="span12 pivotResultRowArea"></div></div>';
				  
	}
	 


	function pivotCloseResult(obj)
	{
		var number=parseInt($(obj).attr("number"));
		
		if(number==1)
			return false;
	
		$("#pivotResultTab"+number).remove();
		$("#pivotResult"+number).remove();
		
	}


	function pivotCalculate(data)
	{
		var activeResultTab=pivotActiveResultTab();
		
		if(activeResultTab.length)
		{
			pivotFilterSetup(data);
			pivotRowSetup(data);
		}			
	}
	
	function pivotActiveResultTab()
	{
		var activeResultTab=$('.pivotResults .tab-pane.active:last');
		
		if(!activeResultTab.length)
			var activeResultTab=$('.pivotResults .tab-pane:last');
		
		if(activeResultTab.length)
		{
			return activeResultTab;
		}	
		else{
			alertify.error('There is no tab place to render data.');		
			return null;
		}
	}

	function pivotRowSetup(data)
	{
		var activeResultTab=pivotActiveResultTab();
		activeResultTab.find('.pivotResultRowArea').html('');
		
		var row={};
		var query={};
		
		//data.db.Where(function(item){ return item.Ad == "Sinan"; }).Select(function(item){ return item.Tutar; })
		
		$('.pivotRowFields a').filter(function(index) {
			return $(this).css("visibility") == 'visible';
		}).each(function(i,val){
		 
			
			var field=$(val).attr("alt");
			row[i]={};
			
			for(var j=0;j<data.unique[field].length;j++){
				 	
				row[i][j]=data.unique[field][j];
				 
				
				if(i==0){	//ilk sirada
					query=data.db.Where(function(item){ return item[field] == data.unique[field][j];});
					console.log(data.unique[field][j], query.items.length);
				}
				else{
					query=query.Where(function(item){ return item[field] == data.unique[field][j];});
					console.log(data.unique[field][j], query.items.length);
				}
				 
			}
			
				
		})		
		
		console.log(row);
	}
	 
	

	function pivotFilterSetup(data)
	{ 
		//filtre kismina suruklenen fieldlardan combo olusturan fonk
		//silinmesi gerekenler varsa sil
		var activeResultTab=pivotActiveResultTab();	
		
		/*
		activeResultTab.find(".pivotResultFilterArea div.pivotFilter").each(function(i,obj){
			var field=$(obj).attr("alt");

			if(!$('.pivotPageFields a[alt='+field+']').length)
				$(obj).remove();

		}); */
		
		activeResultTab.find('.pivotResultFilterArea').html("");
		
		$('.pivotPageFields a').filter(function(index) {
			return $(this).css("visibility") == 'visible';
		}).each(function(i,val){
			var field=$(val).attr("alt");
			pivotMakeFilterCombo(field,data);
		})
		 
 
	 
        $("li.pivotFilterElement").click(function(event){
        	event.stopPropagation();
        });
	
        $("li.pivotFilterElement input").click(function(event){
	        var val=$(this).attr("value");
	        var checked=$(this).attr("checked");
	       
	        if(val=="Select All" )
	        {
	        	if(checked=="checked")
			        $(this).parents("ul").find("input").attr("checked","checked");
			    else
			        $(this).parents("ul").find("input").removeAttr("checked");
	        }
	        else{
	        	if(checked=="checked")
			        $(this).attr("checked","checked");
			    else
			        $(this).removeAttr("checked");		        
	        }
	       
	       var count=$(this).parents("ul").find("input[checked=checked]").length;
	       
	       var name= $(this).parents("div.btn-group").find("a:first").attr("alt");
	        
	       
	       if(count>0)
		       $(this).parents("div.btn-group").find("a:first").html("<strong>"+name+"</strong>: "+ count + " selected"); 
		   else
		       $(this).parents("div.btn-group").find("a:first").html(name); 
		       
		       
		    console.log(val,checked,count,name);   
        });	
	
		
	}
	
 
	function pivotMakeFilterCombo(field, data)
	{
		var activeResultTab=pivotActiveResultTab();	
	
		var maxFilter=parseInt(activeResultTab.find('.pivotFilter:last').attr("number"));
		var tempVal=[];
		
		if(isNaN(maxFilter))
			maxFilter=0;
		
		var combo='<div class="pivotFilter  btn-group" alt="'+field+'">';
		combo+='<a class="btn  btn-mini dropdown-toggle" data-toggle="dropdown" alt="'+field+'" href="#">'+field+' <span class="caret"></span></a>';
		combo+='<ul id="pivotFilter'+(maxFilter+1)+'" class="pivotFilter dropdown-menu" alt="'+field+'" number="'+(maxFilter+1)+'" >';
		combo+='<li class="pivotFilterElement"><a href="#"><label><input type="checkbox" name="'+field+'" class="pivotFilterRealElement" value="Select All" > Select All</label></a></li>';
				
		
		for(var i=0;i<data.rows.length;i++)
		{
			if($.inArray(data.rows[i][field],tempVal)>=0)
			{
			
			}
			else
			{ 
				//combo+='<li ><input type=checkbox>'+data.rows[i][field]+'</input></li>';
				combo+='<li class="pivotFilterElement"><a href="#"><label><input type="checkbox" value="'+data.rows[i][field]+'" > '+data.rows[i][field]+'</label></a></li>';
				tempVal[tempVal.length]=data.rows[i][field];
			}
		}
		
		combo +='</ul></div>';
			  	 
		
		activeResultTab.find('.pivotResultFilterArea').append(combo);	  
	}
	
	


	function pivotDataSetup(plugin)
	{
		var arrCols=[];

		//tablodaki sutunlari ilgili field dizilerinde biriktirir
		plugin.find("th").each(function(i,obj){
			arrCols[i]=$(obj).html();			
		});		
		
		var arrData=[];
		var unique={};
		//var matris={};
		
		plugin.find("tbody tr").each(function(i,obj){
		
			//i satir
			//j field
			
 			arrData[i]={};

			for(var j=0;j<arrCols.length;j++)
			{ 
				arrData[i][arrCols[j]]=$(obj).find("td:eq("+j+")").html();
				 
				
				//console.log(unique[arrCols[j]],typeof(unique[arrCols[j]]));
				
				if(typeof(unique[arrCols[j]])=='undefined'){
					 unique[arrCols[j]]=[];
					// console.log('tanimlanmamis', arrCols[j])
				}
				
				if($.inArray(arrData[i][arrCols[j]], unique[arrCols[j]])>=0)//dizide var
				{
					//console.log('varmis',arrCols[j],arrData[i][arrCols[j]])	
				}
				else
				{ 
					//console.log('yokmus',arrCols[j],arrData[i][arrCols[j]],unique[arrCols[j]])		
					unique[arrCols[j]][unique[arrCols[j]].length]=arrData[i][arrCols[j]];
				}
			}
			
		});
		 
		for(var i in unique)
		{
			//console.log(i, unique[i]);
			unique[i]=unique[i].sort();
		}
		 
		 
		
		
		return {'cols':arrCols,'rows':arrData, 'unique':unique, 'db':JSLINQ(arrData) };
				
	}
	
	
  

  
})( jQuery );

 
